<!doctype html>
<html>
  <head>
    <title>WREN example patches</title>
    <style type = "text/css">
        body
        {
          background-color : #bbbbff;
          background       : url( "./images/primes.jpg");
       /* background       : url( "./prime_wool_lighter.jpg"); */
          font-family      : Verdana, arial, helvetica, sans-serif;
          font-size        : 8pt;
          text-align       : left;
        }
        table
        {
          background       : none;
          padding          : 0px;
          border           : solid;
          border-color     : #cccccc;
          border-width     : 1px;
          font-family      : Verdana, arial, helvetica, sans-serif;
          font-size        : 8pt;
          width            : 96%;
        }
        img
        {
          border           : none;
        }
        td
        {
          background       : url( "./images/trans_blue.png");
          padding          : 3px;
          vertical-align   : top;
          text-align       : left;
        }
        th
        {
          background       : url( "./images/trans_blue.png");
          font             : bold;
          text-align       : left;
          padding          : 3px;
        }

        .left          { text-align : left;   }
        .centered      { text-align : center; }
        .right         { text-align : right;  }

        .tr_description{ width : 60%; text-align: left;  }
        .tr_mp3        { width :  5%;                    }
        .tr_stream     { width :  5%;                    }
        .tr_date       { width : 10%;                    }
        .tr_mb         { width : 10%; text-align: right; }
        .tr_duration   { width : 10%; text-align: center;}

        .all           { background : url( "./images/all.png");              }
        .washing       { background : url( "./images/machine.png") no-repeat;}
        .spacestation  { background : url( "./images/iss.png") no-repeat;    }
        .chuck         { background : url( "./images/code.png");             }
        .ephemera      { background : url( "./images/ephemera.png");         }
        .boiar         { background : url( "./images/boiar.png");            }
        .soldering     { background : url( "./images/soldering.png");        }

    </style>
  </head>

  <body>
    <div>
    <h3>WREN example patches</h3>
    <p>
      As of 2020-04-13 I've just put up all my patches, ripe and green, usable and unusable.
    </p><p>
      As of 2020-07-14 I've updated the repository, currently there are 1329 patches, the zip
      file is about 15 MB.
    </p><p>
      Some will depend on external files being present. The file 1@_all_patches.zip holds all the
      patches (and some other stuff).
    </p><p>
      Some patches may need a later Wren version than your current one, or even a later one than
      the one present on my web site.
    </p><p>
      Some patches were not made by me, but were sent to me as examples for something.
    </p><p>
      To download a patch you can click on it and then use something like the 'save page as' from
      your browser - they are treated as text files by the server. The zip with all patches will
      be treated as a binary file (and may ask for a storage location directly).
    </p>
    <table><tbody>
<?php

  function add_track( $song)
  {
    print( "      <tr><td><a rel=\"noreferrer\" href=\"$song\" target=\"_blank\">$song</a></td></tr>");
  }

  function has_extension( $filename, $ext)
  {
    $parts = explode( '.', $filename);

    $result = strtolower( $parts[ count( $parts) - 1]) == strtolower( $ext);

    return $result;
  }

  function is_viewable( $filename)
  {
    $result =
      ( strlen( $filename) > 0) &&
      ( $filename[ 0] != '.')   &&
      (
        has_extension( $filename, 'wren') ||
        has_extension( $filename, '4th' ) ||
        has_extension( $filename, 'txt' ) ||
        has_extension( $filename, 'zip' ) ||
        has_extension( $filename, 'mp3' ) ||
        has_extension( $filename, 'fla' ) ||
        has_extension( $filename, 'flac') ||
        has_extension( $filename, 'ogg' )
      );

    return $result;
  }


  function get_dir_list()
  {
    $result = array();

    if( $handle = opendir('.'))
    {
      while( false !== ( $entry = readdir( $handle)))
      {
        if(
          $entry != "."  &&
          $entry != ".." &&
          ! is_dir( $entry) &&
          is_viewable( $entry)
        )
        {
          $result[] = $entry;
        }
      }
      closedir( $handle);
    }

    sort( $result, SORT_NATURAL);

    return $result;
  }

  $files = get_dir_list();

  foreach( $files as $file)
  {
    add_track( $file);
  }

?>
    </tbody></table></div>
  </body>
</html>
